# Textbox

A textbox lets users enter and edit text.

## Textbox

![](/files/-MAgBzsgtqe5tt4bvUUn)

```
New-UDTextbox -Label 'Standard' -Placeholder 'Textbox'
New-UDTextbox -Label 'Disabled' -Placeholder 'Textbox' -Disabled
New-UDTextbox -Label 'Textbox' -Value 'With value'
```

## Password Textbox

A password textbox will mask the input.

![](/files/-MAgC1c_frWpotzS1xuD)

```
New-UDTextbox -Label 'Password' -Type password
```

## Multiline

You can create a multiline textbox by using the `-Multiline` parameter. Pressing enter will add a new line. You can define the number of rows and the max number of rows using `-Rows` and `-RowsMax`.

```
New-UDTextbox -Multiline -Rows 4 -RowsMax 10
```

## Interaction

### Retrieving a textbox value

You can use `Get-UDElement` to get the value of a textbox

```
New-UDTextbox -Id 'txtExample' 
New-UDButton -OnClick {
    $Value = (Get-UDElement -Id 'txtExample').value 
    Show-UDToast -Message $Value
} -Text "Get textbox value"
```

### Setting the textbox value

```
New-UDTextbox -Id 'txtExample' -Label 'Label' -Value 'Value'

New-UDButton -OnClick {

    Set-UDElement -Id 'txtExample' -Properties @{
        Value = "test123"
    }

} -Text "Get textbox value"
```

## Icons

You can set the icon of a textbox by using the `-Icon` parameter and the `New-UDIcon` cmdlet.

```
New-UDTextbox -Id "ServerGroups" -Icon (New-UDIcon -Icon 'server') -Value "This is my server"
```

![](/files/-MFetKRtd-x_KM6aShI9)

## Mask

You can define a text mask with a combination of strings and regular expressions. To specify a regular expression, use the JavaScript syntax in your string to start and finish the expression: `/\d/`.

This example creates a mask for US based phone numbers.

```
New-UDTextbox -Mask @('+', '1', ' ', '(', '/[1-9]/', '/\d/', '/\d/', ')', ' ', '/\d/', '/\d/', '/\d/', '-', '/\d/', '/\d/', '/\d/', '/\d/')
```

![](/files/-MKH_lM-fa5MD5UMZqzv)

**New-UDTextbox**

| Name        | Type            | Description                                                              | Required |
| ----------- | --------------- | ------------------------------------------------------------------------ | -------- |
| Id          | String          | The ID of the component. It defaults to a random GUID.                   | false    |
| Label       | String          | A label to show above this textbox.                                      | false    |
| Placeholder | String          | A placeholder to place within the text box.                              | false    |
| Value       | Object          | The current value of the textbox.                                        | false    |
| Type        | String          | The type of textbox. This can be values such as text, password or email. | false    |
| Disabled    | SwitchParameter | Whether this textbox is disabled.                                        | false    |
| Icon        | Object          | The icon to show next to the textbox.                                    | false    |
| Autofocus   | SwitchParameter | Whether to autofocus this textbox.                                       | false    |
| Multiline   | SwitchParameter | Whether the textbox accepts multiple lines.                              | false    |
| Rows        | int             | The number of rows in a multiline textbox                                | false    |
| RowsMax     | int             | The max number of rows in a multiline textbox                            | false    |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.powershelluniversal.com/v1/dashboard/components/inputs/textbox.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
